Skip to main content

Workgroup API (JSON)

The workgroup web service provides a programmatic way to perform all of the same transactions that can be done in Workgroup Manager.

This includes:

  • Search for a workgroup by name
  • Search for workgroups by an identifier (Certificate, Person or Workgroup Name)
  • Getting the details of a workgroup
  • Creating and deleting a new workgroup from an existing stem
  • Updating workgroup attributes
  • Getting the privgroup of a workgroup
  • Getting the workgroup integrations linkage of a workgroup
  • Adding and deleting members
  • Adding and deleting administrators
  • Adding and delete workgroup integration linkage
  • Workgroup Transactional History

How to get started with the Workgroup API

Follow the Middleware and Integration Services Integration (MaIS) checklist for RESTful Web Services. If you need help, are not sure whether the Web APIs are the best method for integrating with the registry, or just have some questions, contact the MaIS team.

HTTP Status codes

CODECONDITIONS
200 OKThe usual successful return code.
201 OKThe usual successful return code for a create (POST).
400 Bad RequestMissing required parameters or identifier is in wrong format.
401 Authorization RequiredThe request was made without certificate.
403 Access DeniedThe request was made without valid certificate.
404 Not FoundThe record you're looking for doesn't exist.
409 ConflictAlready exists
500 Internal Server ErrorSomething broke with our code. Please tell us about it.

Error handling

Workgroup API sends error status via standard HTTP status codes (4xx) and always returns an Json document detailing the error. For example, when a client makes a call to update a workgroup filter with no supported filter value, the system will return the following Json error document:

PUT https://workgroupsvc.stanford.edu/workgroups/2.0/mais:new?filter=standard 

Status: 400
Content-Type: application/json

{
  "notification": "Unsupported FILTER value of STANDARD. Supported values are ACADEMIC_ADMINISTRATIVE, FACULTY, STAFF, STUDENT, FACULTY_STAFF, FACULTY_STUDENT, STAFF_STUDENT, FACULTY_STAFF_STUDENT, NONE",
  "code": 400,
  "message": "Bad Request",
  "status": 400
}

Search workgroup by name

Description

Retrieve a list of active workgroups based on {SEARCH STRING}. Search String length must be at least 4 characters before using wildcards. If no wildcards are used then it will search for an exact match of the {SEARCH STRING}. You cannot start with a wildcard. If timeout happens then increase the search string characters before the wildcard. 

Note: Private workgroups are not shown unless your CERT is added as an admin

URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/search/{SEARCH STRING}
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/search/{SEARCH STRING}
MethodGET
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

GET https://workgroupsvc.stanford.edu/workgroups/2.0/search/mais*
Status: 200
Content-Type: application/json
{
  "search" : "mais:*",
  "results": [
    {
      "name": "mais:staff",
      "description": "Staff of AS/Middleware and Integration Services",
      "integrations": [{ "GOOGLE": "mais-staff" },
                       { "MAILING_LIST": "mais-all-staff" } ],
      "lastUpdate": "22-JUL-2019", 
      "lastUpdateBy": "workgroup_maint",
      "memberCount": "8"
    }, {
      "name": "workgroup:mais",
      "description": "Staff of AS/Middleware and Integration Services",
      "integrations": [" {"PTS": "workgroup:mais" } ],
      "lastUpdate": "22-JUL-2019",
      "lastUpdateBy": "workgroup_maint",
      "memberCount": "8"
    }, ...
  ]
}

Search for workgroups by an identifier (Certificate, Person or Workgroup Name)

Description

Retrieve a list of active workgroups where the identifier of that type (Certificate, Person or Workgroup) is a member or administrator including where the identifier is nested.

Note: Private workgroups are not shown unless your CERT is added as an admin

URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/
or
https://workgroupsvc.stanford.edu/workgroups/2.0?type={CERTIFICATE | USER | WORKGROUP}&id={input value}&lite={TRUE | FALSE}
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0?type={CERTIFICATE | USER | WORKGROUP}&id={input value}&lite={TRUE | FALSE}
MethodGET
Parameter Fieldstype:    CERTIFICATE | USER | WORKGROUP
id:    Identifier value   
lite: TRUE | FALSE
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

GET https://workgroupsvc.stanford.edu/workgroups/2.0

{
  "type" : "USER",
  "id": "jespin07"
}

{
  "type" : "WORKGROUP",
  "id": "mais:staff"
}

{
  "type" : "USER",
  "id": "jespin07",
  "lite": "TRUE"
}

Status: 200
Content-Type: application/json
{
  "type": "WORKGROUP",
  "id": "mais:staff",
  "members": [
    {
      "name": "asview:mais-admin-prd",
      "description": "Workgroup for SUNAC access to MAIS PRD env",
      "integrations": [{ "MAILING_LIST": "mais-all-staff" }],
      "lastUpdate": "22-JUL-2019", 
      "lastUpdateBy": "workgroup_maint",
      "memberCount": "5"
    }, {
      "name": "deviceregistry:mydevices-search",
      "description": "My Devices Search tab access",
      "integrations": [],
      "lastUpdate": "22-JUL-2019",
      "lastUpdate_by": "workgroup_maint",
      "memberCount": "193"
    }
  ],
  "administrators": [
    {
      "name": "deviceregistry:mydevices-search",
      "description": "My Devices Search tab access",
      "integrations": [],
      "lastUpdate": "22-JUL-2019", 
      "lastUpdateBy": "workgroup_maint",
      "memberCount": "193"
    }
  ]
}

LITE OUTPUT:

Status: 200
Content-Type: application/json

{
"type": "WORKGROUP",
"id": "mais:staff",
"members_count": 2,
"members": [
"asview:mais-admin-prd",
      "deviceregistry:mydevices-search"
  ],
  "administrators_count": 1,
  "administrators": [
"deviceregistry:mydevices-search"
]
}

Get workgroup

DescriptionRetrieve information on an active workgroup including integration, members and administrators
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}
MethodGET
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

If the authenticated user is a workgroup administrator, the JSON document will include public information (description, filter, visibility, privgroup, and reusable) and private information (members and administrators). If the authenticated user is not an administrator, the JSON document will include only public information. Note: "authenticated user" can be a certificate name, which must be configured as a workgroup administrator.

GET https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff
Status: 200
Content-Type: application/json
{
  "name": "mais:staff",
  "description": "Staff of AS/Middleware and Integration Services",
  "filter": "NONE",
  "visibility": "STANFORD",
  "reusable": "TRUE",
  "privgroup": "TRUE",
  "integrations": [{ "GOOGLE": "mais-staff" },
                   { "MAILING_LIST": "mais-all-staff" }],
  "lastUpdate": "22-JUL-2019",
  "lastUpdateBy": "workgroup_maint",
  "members": [
    {
      "type": "PERSON",
      "id": "chowhan",
      "name": "Chowhan, Sangeetha"
    }, {
      "type": "PERSON",
      "id": "hlclark",
      "name": "Clark, Helen"
    }, {
      "type": "WORKGROUP",
      "id": "workgroup:mais",
      "name": "workgroup:mais"
    }, {
      "type": "CERTIFICATE",
      "id": "www.stanford.edu",
      "name": "www.stanford.edu"
    } ],
  "administrators" : [
    {
      "type": "PERSON",
      "id": "smarella",
      "name": "Marella, Sameer"
    }, {
      "type": "WORKGROUP",
      "id": "workgroup:mais-owners",
      "name": "workgroup:mais-owners"
    } ]
}

Create workgroup

DescriptionCreate a new workgroup, where the name is limited to 60 characters or less and items parameters in RED are the default values
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}?description={description}&filter={filter}&visibility={visibility}&privgroup={privgroup}
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}?description={description}&filter={filter}&visibility={visibility}&privgroup={privgroup}
MethodPOST
Parameter Fieldsdescription*:    If the workgroup description contains more than 255 characters, only the first 255 characters are used. *Cannot be empty or blank.
filter:    ACADEMIC_ADMINISTRATIVE | STUDENT | FACULTY | STAFF | FACULTY_STAFF | FACULTY_STUDENT | STAFF_STUDENT | FACULTY_STAFF_STUDENT | NONE
reusable:    TRUE | FALSE
visibility:    PRIVATE | STANFORD
privgroup:    TRUE | FALSE
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

POST https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff

{
  "description" : "Staff of AS/Middleware and Integration Services",
  "reusable" : "TRUE",
  "privgroup" : "FALSE",
}


Status: 201
Content-Type: application/json
{
  "name": "mais:staff",
  "description": "Staff of AS/Middleware and Integration Services",
  "filter": "NONE",
  "visibility": "STANFORD",
  "reusable": "TRUE",
  "privgroup": "FALSE",
  "integrations": [],
  "lastUpdate": "22-JUL-2019",
  "lastUpdateBy": "workgroup_maint",
  "members": [],
  "administrators" : [
    {
      "type" : "PERSON",
      "id" : "etlouie",
      "name" : "Louie, Edward",
    } ]
}

Update workgroup

DescriptionUpdate information of a workgroup. The returning JSON will be the return the same information as if the user called the Get Workgroup By Name API call. You only need to specify the fields you wish to update. If no fields are passed then nothing is updated.
Adding and Removing Members or Administrators or Linking and Unlinking Integration Points are not available in this API, there are separate API end points to perform those functionalities.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}?description={description}&filter={filter}&visibility={visibility}&privgroup={privgroup}
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}?description={description}&filter={filter}&visibility={visibility}&privgroup={privgroup}
MethodPUT
Paramater Fieldsdescription*:    If the workgroup description contains more than 255 characters, only the first 255 characters are used. *Cannot be empty or blank.
filter:    ACADEMIC_ADMINISTRATIVE | STUDENT | FACULTY | STAFF | FACULTY_STAFF | FACULTY_STUDENT | STAFF_STUDENT | FACULTY_STAFF_STUDENT | NONE
reusable:    TRUE | FALSE
visibility:    PRIVATE | STANFORD
privgroup:    TRUE | FALSE
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

PUT https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff 

{
  "description" : "Staff of AS/Middleware and Integration Services",
  "reusable" : "TRUE",
  "privgroup" : "FALSE",
}


Status: 201
Content-Type: application/json
{
  "name": "mais:staff",
  "description": "Staff of AS/Middleware and Integration Services",
  "filter": "NONE",
  "visibility": "STANFORD",
  "reusable": "TRUE",
  "privgroup": "FALSE",
  "integrations": [],
  "lastUpdate": "22-JUL-2019",
  "lastUpdateBy": "workgroup_maint",
  "members": [],
  "administrators" : [
    {
      "type" : "PERSON",
      "id" : "etlouie",
      "name" : "Louie, Edward",
    } ]
}

Delete workgroup

DescriptionThese active workgroups are marked inactive and are retained in the system for future reference, however all members and administrators will be removed. If you try to inactivate an inactive workgroup, you'll get a 404 Not Found error.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}
MethodDELETE
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

DELETE https://workgroupsvc.stanford.edu/workgroups/2.0/mais:wgapi 

Status: 200
Content-Type: application/json
{
  "status": "200",
  "code": "200",
  "message": "Deleted",
  "notification": "Workgroup: mais:wgapi has been deleted and all members and administrators removed"
}

Get privilege group for a workgroup

DescriptionGet Privilege Group Members from a Workgroup. By default, if no Query Parameter or JSON body is used, the API will return both MEMBERS and ADMINISTRATORS within its own key. If the workgroup is private and your certificate is not an administrator, you will receive a 200 response, but with empty lists and the message: "This is a private workgroup!".
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/privgroup
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/privgroup?role={ MEMBERS | ADMINISTRATORS}
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/privgroup
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/privgroup?role={ MEMBERS | ADMINISTRATORS}
MethodGET
Parameter Fieldsrole:    MEMBERS | ADMINISTRATORS
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

GET https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/privgroup 

{
  "role": "MEMBER"

Status: 200
Content-Type: application/json
{
  "name": "mais:staff",
  "members": [
    {
      "name": "Louie, Edward ",
      "id": "etlouie",
      "lastUpdate": "22-JUL-2019"
    }, {
      "name": "Chowhan, Sangeetha",
      "id": "chowhan",
      "lastUpdate": "22-JUL-2019"
    }
  ],
  "administrators": [
    {
      "name": "Chowhan, Sangeetha",
      "id": "chowhan",
      "lastUpdate": "22-JUL-2019"
    }
  ]
}

Add member to workgroup

DescriptionAdd an existing SUNet ID or workgroup to a workgroup as a member, with optional comment and a possible expiry date. If an expiry date is passed, the SUNet ID or workgroup will be removed after that date.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/members/{sunetid | workgroup-name}
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/members/{sunetid | workgroup-name}?type={ USER | WORKGROUP }&COMMENT=<text>&EXPIRYDT=<YYYY-MM-DD>
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/members/{sunetid | workgroup-name}
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/members/{sunetid | workgroup-name}?type={ USER | WORKGROUP }&COMMENT=<text>&EXPIRYDT=<YYYY-MM-DD>
MethodPUT
Paramter Fieldstype:    USER | WORKGROUP
comment: optional free text   
expirydt: optional YYYY-MM-DD    
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

PUT https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/members/etlouie 

{
  "type": "USER",
  "comment": <optional text">,
  "expirydt": "<optional YYYY-MM-DD>"

Status: 200
Content-Type: application/json
{
  "status": "200",
  "code": "200",
  "message": "Added",
  "notification": "etlouie was added as a member to the workgroup: mais:staff"
}

Remove member from workgroup

DescriptionRemove a member of type person or workgroup from a workgroup, with optional comment.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/members/{sunetid | workgroup-name}
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/members/{sunetid | workgroup-name}?type={ USER | WORKGROUP }&COMMENT=<text>
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/members/{sunetid | workgroup-name}
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/members/{sunetid | workgroup-name}?type={ USER | WORKGROUP }&COMMENT=<text>
MethodDELETE
Parameter Fieldstype:    USER | WORKGROUP
comment: optional free text 
Returns200 Ok
400 Bad Request
401 Unauthorized
404 Not Found

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

Note: Deleted workgroups and memberships are marked inactive and retained in the system for future reference.

DELETE  https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/members/etlouie 

{
  "type": "USER"
}

Status: 200
Content-Type: application/json
{
  "status": "200",
  "code": "200",
  "message": "Removed",
  "notification": "etlouie was removed as a member to the workgroup: mais:staff"
}

Get members from a Workgroup or linked Workgroup

DescriptionRetrieves the members from a Workgroup or a Linked Workgroup, if the linkage exists. The resulting JSON will return back the name of the workgroup, members and the linkage name, if any.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/members
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/members?link={ GOOGLE | MAILING_LIST | PTS }
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/members
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/members?link={ GOOGLE | MAILING_LIST | PTS }
MethodGET
Parameter Fieldslink: GOOGLE | MAILING_LIST | PTS 
Returns200 OK 
400 Bad Request
401 Unauthorized
404 Not Found

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

PUT https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/administrators/etlouie 

{
  "type": "USER"
}

Status: 200
Content-Type: application/json
{
  "status": "200",
  "code": "200",
  "message": "Added",
  "notification": "etlouie was added as an administrator to the workgroup: mais:staff"
}

Add administrator to workgroup

DescriptionAdd an existing SUNet ID, workgroup or certificate to a workgroup as an administrator, with optional comment.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/administrators/{sunetid | workgroup-name | certificate-name}
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/administrators/{sunetid | workgroup-name | certificate-name}?type={ USER | WORKGROUP | CERTIFICATE }&COMMENT=<text>
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/administrators/{sunetid | workgroup-name | certificate-name}
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/administrators/{sunetid | workgroup-name | certificate-name}?type={ USER | WORKGROUP | CERTIFICATE }&COMMENT=<text>
MethodPUT
Parameter Fieldstype:    CERTIFICATE | USER | WORKGROUP
comment: optional free text 
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

PUT https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/administrators/etlouie 

{
  "type": "USER",
  "comment": "optional text"
}

Status: 200
Content-Type: application/json
{
  "status": "200",
  "code": "200",
  "message": "Added",
  "notification": "etlouie was added as an administrator to the workgroup: mais:staff"
}

Remove administrator from workgroup

DescriptionRemove an administrator of type person, workgroup or certificate from a workgroup, with optional comment.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/administrators/{sunetid | workgroup-name | certificate-name}
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/administrators/{sunetid | workgroup-name | certificate-name}?type={ USER | WORKGROUP | CERTIFICATE }&COMMENT=<text>
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/administrators/{sunetid | workgroup-name | certificate-name}
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/administrators/{sunetid | workgroup-name | certificate-name}?type={ USER | WORKGROUP | CERTIFICATE }&COMMENT=<text>
MethodDELETE
Parameter Fieldstype:    CERTIFICATE | USER | WORKGROUP
comment: optional free text 
Returns201 Created
400 Bad Request
401 Unauthorized
409 Conflict

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

Note: Deleted workgroups and memberships are marked inactive and retained in the system for future reference.

DELETE  https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/administrators/etlouie 

{
  "type": "USER"
}

Status: 200
Content-Type: application/json
{
  "status": "200",
  "code": "200",
  "message": "Removed",
  "notification": "etlouie was removed as an administrator to the workgroup: mais:staff"
}

Get Administrators from a Workgroup or linked Workgroup

DescriptionRetrieves the administrators from a Workgroup or a Linked Workgroup, if a linkage exists. The resulting JSON will return back the name of the workgroup, members and the linkage name, if any.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/members
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/members?link={ GOOGLE | MAILING_LIST | PTS }
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/members
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/members?link={ GOOGLE | MAILING_LIST | PTS }
MethodGET
Parameter Fieldslink: GOOGLE | MAILING_LIST | PTS 
Returns200 OK 
400 Bad Request
401 Unauthorized
404 Not Found

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

PUT https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/administrators/etlouie 

{
  "type": "USER"
}

Status: 200
Content-Type: application/json
{
  "status": "200",
  "code": "200",
  "message": "Added",
  "notification": "etlouie was added as an administrator to the workgroup: mais:staff"
}

Get integration of a workgroup

DescriptionShow only the integration link of a workgroup
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/links
UAT URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/links
MethodGET
Returns200 OK 
401 Unauthorized
404 Not Found

GET https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/links 

Status: 200
Content-Type: application/json
{
  "name" : "mais:staff",
  "integrations": [{ "OFFICE365": "mais-staff" },
                   { "MAILING_LIST": "mais-all-staff" }]
}

Add link integration to a workgroup

DescriptionAdd an integration link to a Workgroup, with optional comment. Using parameter Link require a secondary parameter Value for Mailing List and PTS. All the other values are defaulted to the workgroup name which cannot be changed. Google currently has a 60 character limit so if you cannot create a link then the reason is that the workgroup could be greater than the allowed integration character length. The resulting JSON will return back the name of the workgroup and the current Integration Links of that workgroup.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/links
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/links?link={ GOOGLE | MAILING_LIST | PTS }&value={input value}&COMMENT=<text>
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/links
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/links?link={ GOOGLE | MAILING_LIST | PTS }&value={input value}&COMMENT=<text>
MethodPUT
Parameter Fieldslink:    GOOGLE | MAILING_LIST | OFFICE365 | PTS 
value: Required only for link value of MAILING_LIST and PTS. If entered for other link value, they shall be ignored.
comment: optional free text 
Returns200 OK and JSON Message
400 Bad Request
401 Unauthorized
404 Not Found

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

PUT https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/links 

{
  "link": "MAILING_LIST",
  "value": "mymailinglist",
  "comment": "optional text"
}

Status: 200
Content-Type: application/json
{
  "name" : "mais:staff",
  "integrations": [{ "OFFICE365": "mais-staff" },
                   { "MAILING_LIST": "mais-all-staff" }]
}

Remove link integration from a workgroup

DescriptionRemove an integration link from a Workgroup. The resulting JSON will return back the name of the workgroup and the current Integration Links of that workgroup, if any.
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/links
or
https://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/links?link={ BOX | GOOGLE | MAILING_LIST | PTS }&COMMENT=<text>
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/links
or
https://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/links?link={ BOX | GOOGLE | MAILING_LIST | PTS }&COMMENT=<text>
MethodDELETE
Parameter Fieldslink:    GOOGLE | MAILING_LIST | OFFICE365 | PTS 
comment: optional free text 
Returns200 OK and JSON Message
400 Bad Request
401 Unauthorized
404 Not Found

Only workgroup administrators are allowed to operate on a workgroup. Please note that the certificate used to authenticate with the API needs to be configured as a workgroup administrator.

DELETE https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/links

{
  "link": "MAILING_LIST",
}

Status: 200
Content-Type: application/json
{
  "name" : "mais:staff",
  "integrations": [{ "OFFICE365": "mais-staff" } ]
}

Workgroup Transactional History

DescriptionGet all the Transactions/Comment History from a workgroup 
URLhttps://workgroupsvc.stanford.edu/workgroups/2.0/{workgroup-name}/history 
UAT URLhttps://workgroupsvc-uat.stanford.edu/workgroups/2.0/{workgroup-name}/history 
MethodGET 
Returns200 OK 
400 Bad Request
401 Unauthorized
404 Not Found

GET https://workgroupsvc.stanford.edu/workgroups/2.0/mais:staff/history

{

  "status": 200,
  "name" : <workgroup-name>,
  "active": true,
  "history":[
    { "create_date": "YYYY-MM-DD", "comment": "<text>" }, 
    { "create_date": "YYYY-MM-DD", "comment": "<text>" },
    ...
  ]
}

Last modified